/******************* ARQUIVO GERA.C      **********************/

# define NOMAIN

# include <stdio.h>
# include <math.h>
# include <time.h>
# include <stdlib.h>

# include "include.h"
# include "struct.h"
# include "global.h"

float gera_tempo(tipo, t_proc_medio, t_proc_inf, t_proc_sup)

int	tipo; 		/* 1-expon. 2-uniforme 3-qualquer */
float   t_proc_medio; 	/* media da dist. exponencial */
float	t_proc_inf; 	/* lim. inf. da dist. uniforme */
float 	t_proc_sup;	/* lim. sup. da dist. uniforme */

{

float   t_randon = 0.0;  /* saida da funcao :tempo de servico ou */
			 /* geracao de um cliente */
float   num_alea = 0.0;  /* num aleatorio entre 0 e 1 obtido pela */
			 /* funcao rand() do C */

num_alea = (float) rand () / ((float) RAND_MAX + 1.0 );


switch (tipo)
	{
	case 1 : /*  Distribuicao exponencial */

		t_randon = -((t_proc_medio)*(log(1.-num_alea)));
		break;

	case 2 : /*  Distribuicao uniforme */

		t_randon = t_proc_inf+(num_alea*(t_proc_sup-t_proc_inf));
		break;

	default :
				      /* 01234567890123456789012345 */
		printf("\n \n %s %s %s","Erro grave de edicao TIPO ",
					"do elemento XXXXX ",
					"definido incorreto");
	}
return(t_randon+t_simul);
}
